/*
 *	Netgrind -- Link Layer Analyser
 *
 *	(c) 2003 Martin Mares <mj@ucw.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#include "lib/lib.h"
#include "netgrind/pkt.h"
#include "netgrind/netgrind.h"

#include <stdio.h>
#include <netinet/in.h>
#include <net/ethernet.h>

struct pkt_stats stat_link_dwarf, stat_link_in, stat_link_unknown, stat_link_arp;

void link_eth_got_packet(struct pkt *p)
{
  struct ether_header *eth;
  uns etype;

  pkt_account(&stat_link_in, p);
  if (!(eth = pkt_pop(p, sizeof(*eth))))
    {
      pkt_account(&stat_link_dwarf, p);
      return;
    }
  etype = ntohs(eth->ether_type);
  switch (etype)
    {
    case ETHERTYPE_IP:
      ip_got_packet(p);
      break;
    case ETHERTYPE_ARP:
      pkt_account(&stat_link_arp, p);
      pkt_free(p);
      break;
    default:
      // printf("Unknown ethertype: %04x\n", etype);
      pkt_account(&stat_link_unknown, p);
      pkt_free(p);
    }
}
