/*
 *	Netgrind -- Packet Buffers
 *
 *	(c) 2003 Martin Mares <mj@ucw.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#include "lib/lib.h"
#include "netgrind/pkt.h"

#include <stdlib.h>

struct pkt *pkt_new(uns preroom, uns postroom)
{
  uns len = preroom + postroom;
  struct pkt *p = xmalloc(sizeof(struct pkt) + len);
  p->stop = p->data = p->buf + preroom;
  p->ebuf = p->buf + len;
  return p;
}

void pkt_free(struct pkt *p)
{
  xfree(p);
}

void pkt_flush_queue(list *l)
{
  struct pkt *p;
  while (p = list_head(l))
    {
      list_remove(&p->n);
      pkt_free(p);
    }
}
